/**@Author: 
 * Diana Mei Leng Wong
 * Michiko Chand
 * Nazih Ajami
 *@Date: November 8, 2006
 
 *Description: 
 *This class is the owner of all award related data. Any GUI that needs any Award information has to 
 *call methods in this class. This class will support returning one specific award, a list of awards or 
 *adding new awards. Currently the class has the possible award values hard coded into it, 
 *which will be changed with the introduction of the database in proto type 2. 
 *The GUI user will never interact with this class.
 */

import java.sql.SQLException;

public class Award {

	public Award(String awardName, String awardDescription,
			String awardFrequency) throws SQLException {

		String sqlInsert;

		ConnectToDB.createConnection();
		sqlInsert = "Insert INTO [Award] (awardName, awardDescription, awardFrequency) SELECT ('"
				+ awardName
				+ "', '"
				+ awardDescription
				+ "', '"
				+ awardFrequency + "')";

		ConnectToDB.runQuery(sqlInsert);

		ConnectToDB.closeConnection();

	}

	// ---testing
	public static void main(String[] args) throws SQLException {

		// String[] names;
		// names = getAllAwardName();
		// System.out.println("Test: getAllAwardName() \n" + names[0] + "\n"
		// + names[3] + "\n" + names[5]);
		System.out.println("Test: getAwardName(2) - " + getAwardName(2));
		System.out.println("Test: getAwardDescription(getAwardName(2)) - "
				+ getAwardDescription(getAwardName(2)));
		// System.out.println("Test: getAwardDescription(3) - "
		// + getAwardDescription(3));

	}

	public static String getAwardName(int awardID) throws SQLException {

		String awardName = null;
		String sqlSelect;

		ConnectToDB.createConnection();
		sqlSelect = "SELECT awardName FROM [Award] WHERE awardID = " + awardID;

		ConnectToDB.setQuery(sqlSelect);

		awardName = ConnectToDB.getValue();

		ConnectToDB.closeConnection();

		return awardName;
	}

	public static int getAwardID(String awardName) throws SQLException {

		int AwardID = 0;
		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT awardID FROM [Award] WHERE awardName = '"
				+ awardName + "'";

		ConnectToDB.setQuery(sqlSelect);

		AwardID = ConnectToDB.getID();

		ConnectToDB.closeConnection();

		return AwardID;
	}

	public static String getAwardDescription(int awardID) throws SQLException {

		String awardDescription = null;
		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT awardDescription FROM [Award] WHERE awardID = "
				+ awardID;

		ConnectToDB.setQuery(sqlSelect);

		awardDescription = ConnectToDB.getValue();

		ConnectToDB.closeConnection();

		return awardDescription;
	}

	public static String getAwardDescription(String awardName)
			throws SQLException {

		String awardDescription = null;
		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT awardDescription FROM [Award] WHERE awardName = '"
				+ awardName + "'";

		ConnectToDB.setQuery(sqlSelect);

		awardDescription = ConnectToDB.getValue();

		ConnectToDB.closeConnection();

		return awardDescription;
	}

	public static String[] getAllAwardName() throws SQLException {

		String sqlSelect;

		ConnectToDB.createConnection();

		sqlSelect = "SELECT awardName FROM [Award]";

		ConnectToDB.setQuery(sqlSelect);

		String[] awardNameList = new String[ConnectToDB.numberOfRows + 1];
		
		//awardNameList[0] = "<Please select>";
		
		awardNameList = ConnectToDB.getList();

		ConnectToDB.closeConnection();

		return awardNameList;
	}
}
