import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;

import javax.swing.JOptionPane;

public class ConnectToDB {

	public static Connection con = null;

	public static Statement s = null;

	public static Statement queryStatement = null;

	public static ResultSet resultSet;

	public static ResultSet rs;

	public static int numberOfRows;

	public static String getValue = null;

	public static int ID = 0;

	private static boolean isConnected = false;

	private static ResultSetMetaData metaData;

	public static void createConnection() {
		try {
			Class.forName("sun.jdbc.odbc.JdbcOdbcDriver");
			String filename = "db/dbEA.mdb";
			String database = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ=";
			database += filename.trim() + ";DriverID=22;READONLY=true}";
			con = DriverManager.getConnection(database, "", "");
			s = con.createStatement();
			isConnected = true;
		} catch (Exception err) {
			System.out.println("ERROR: " + err);
		}
	}

	public static void setQuery(String query) throws SQLException,
			IllegalStateException {

		// resultSet.close();
		if (!isConnected)
			throw new IllegalStateException("Not Connected to Database");

		s = con.createStatement(ResultSet.TYPE_SCROLL_SENSITIVE,
				ResultSet.CONCUR_UPDATABLE);
		System.out.println("" + query);
		resultSet = s.executeQuery(query);

		metaData = resultSet.getMetaData();

		resultSet.last();

		numberOfRows = resultSet.getRow();

		System.out.println("Total rows for the query: " + numberOfRows);
		System.out.println("Total columns for the query: " + getColumnCount());
	}

	public int getRowCount() throws SQLException {

		if (!isConnected)
			throw new IllegalStateException("Not Connected to Database");

		return numberOfRows;
	}

	public static int getColumnCount() throws IllegalStateException {

		if (!isConnected)
			throw new IllegalStateException("Not Connected to Database");

		try {
			return metaData.getColumnCount();
		} catch (SQLException sqlException) {
			sqlException.printStackTrace();
		}

		return 0;
	}

	public static String[] getList() throws SQLException {
		String[] getList = new String[numberOfRows];
		// System.out.println("First part");
		if (!isConnected)
			throw new IllegalStateException("Not Connected to Database");

		try {
			resultSet.beforeFirst();
			// System.out.println("Hey there");
			int i = 0;
			
			while (resultSet.next()) {
				// System.out.println(resultSet.getString(1));
				getList[i] = resultSet.getString(1);
				i++;
			}
		} catch (SQLException sqlException) {
			sqlException.printStackTrace();
		}
		resultSet.close();
		return getList;
	}

	public static String getValue() throws SQLException {

		if (!isConnected)
			throw new IllegalStateException("Not Connected to Database");

		try {

			getValue = resultSet.getString(1);

		} catch (SQLException sqlException) {
			sqlException.printStackTrace();
		}
		resultSet.close();
		return getValue;
	}

	public static int getID() throws SQLException {

		if (!isConnected)
			throw new IllegalStateException("Not Connected to Database");

		try {

			ID = resultSet.getInt(1);

		} catch (SQLException sqlException) {
			sqlException.printStackTrace();
		}
		resultSet.close();
		return ID;
	}

	public static void runQuery(String Query) throws SQLException {

		try {
			s.executeUpdate(Query);
		} catch (Exception ex) {
			System.out.println("Error in transaction");
		}
	}

	public static void closeConnection() throws SQLException {
		if (!isConnected)
			throw new IllegalStateException("Not Connected to Database");
		try {
			con.close();
			s.close();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	// ---testing---
	public static void main(String[] args) throws SQLException {

		createConnection();

		System.out.println(isConnected);

		closeConnection();

	}

	public String getColumnName(int column) throws IllegalStateException {

		if (!isConnected)
			throw new IllegalStateException("Not Connected to Database");

		try {
			return metaData.getColumnName(column + 1);
		} catch (SQLException sqlException) {
			sqlException.printStackTrace();
		}

		return "";
	}

	public Class getColumnClass(int column) throws IllegalStateException {

		if (!isConnected)
			throw new IllegalStateException("Not Connected to Database");

		try {
			String className = metaData.getColumnClassName(column + 1);

			return Class.forName(className);
		} catch (Exception exception) {
			exception.printStackTrace();
		}

		return Object.class;
	}

	public Object getValueAt(int row, int column) throws IllegalStateException {

		if (!isConnected)
			throw new IllegalStateException("Not Connected to Database");

		try {
			resultSet.absolute(row + 1);
			return resultSet.getObject(column + 1);

		} catch (SQLException sqlException) {
			sqlException.printStackTrace();
		}

		return "";
	}

	public String getTableName(int Column) {
		try {
			return metaData.getTableName(Column);

		} catch (Exception ex) {
			ex.printStackTrace();
		}

		return "";
	}

	protected static void UnloadWindow() {
		String ObjButtons[] = { "Yes", "No" };
		int PromptResult = 1;
		PromptResult = JOptionPane.showOptionDialog(null,
				"Are you sure you want to log-out?", "Employees Awards System",
				JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE, null,
				ObjButtons, ObjButtons[1]);
		if (PromptResult == 0) {
			System.out
					.println("\n\n"
							+ " ------------------------------------------------------------\n\n"
							+ " THANK YOU FOR USING EMPLOYEES AWARDS SYSTEM VERSION 1.1\n\n"
							+ " ------------------------------------------------------------\n\n"
							+ " Programmer: Diana\n"
							+ " Email Address: dianameilengwong@yahoo.com\n\n"
							+ " Programmer: Michiko\n"
							+ " Email Address: michikochand@yahoo.com\n\n"
							+ " Programmer: Nino\n"
							+ " Email Address: najami@yahoo.com\n\n"
							+ " ------------------------------------------------------------\n"
							+ "\n\n");
			System.exit(0);
		}
	}
	
	

}
