/**@Author: 
 * Diana Mei Leng Wong
 * Michiko Chand
 * Nazih Ajami
 *@Date: November 8, 2006

 *Description: 
 *This class creates the GUI that the user encounters if they select the navigation option to vote 
 *for an employee. Based on the application business rules only managers with valid user name and 
 *password are allowed to vote for award winners. Therefore, the application only allows valid users 
 *to enter the vote for an employee form. This class invokes the isPasswordCorrect.java class to 
 *validate the password, the user name is currently hard coded into this class as Merkle. 
 *For prototype 2, the hard coded elements of this class will be removed and the class will call a 
 *method in the Employee class to validate both the user name and password from the database.
 */

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.IOException;
import java.net.URL;
import java.sql.SQLException;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JRootPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

public class LoginGUI {

	JFrame mainWindow;

	String username;

	char[] password;

	JTextField loginField = new JTextField();

	JPasswordField passField = new JPasswordField(20);

	URL url = null;

	JLabel forgotText = new JLabel();

	public static void main(String args[]) {
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				new LoginGUI();
			}
		});
	}

	public LoginGUI() {
		// ======== mainWindowFrame ========
		mainWindow = new JFrame();
		mainWindow.setTitle("Log-in to Vote");
		mainWindow.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		mainWindow.setLocation(300, 100);

		JPanel dialogPane = new JPanel();
		dialogPane.setLayout(new BorderLayout());
		dialogPane.setPreferredSize(new Dimension(500, 400));
		mainWindow.setContentPane(dialogPane);

		JPanel contentPanel = new JPanel();
		JPanel logoPanel = new JPanel();
		JPanel loginPanel = new JPanel();
		JLabel loginLabel = new JLabel();
		JLabel passwordLabel = new JLabel();
		JPanel buttonPanel = new JPanel();
		JButton loginButton = new JButton();
		JButton cancelButton = new JButton();
		JCheckBox rememberBox = new JCheckBox();
		JTextArea remindText = new JTextArea();
		JPanel logPanel = new JPanel();
		JPanel passPanel = new JPanel();
		JRootPane root = mainWindow.getRootPane();

		{
			dialogPane.setBorder(new EmptyBorder(0, 0, 0, 0));
			dialogPane
					.setBorder(new javax.swing.border.CompoundBorder(
							new javax.swing.border.TitledBorder(
									new javax.swing.border.EmptyBorder(0, 0, 0,
											0), " ",
									javax.swing.border.TitledBorder.CENTER,
									javax.swing.border.TitledBorder.BOTTOM,
									new java.awt.Font("Dialog",
											java.awt.Font.BOLD, 12),
									java.awt.Color.red), dialogPane.getBorder()));
			dialogPane
					.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
						public void propertyChange(
								java.beans.PropertyChangeEvent e) {
							if ("border".equals(e.getPropertyName()))
								throw new RuntimeException();
						}
					});

			dialogPane.setLayout(new BorderLayout());

			// ======== contentPanel ========
			{
				contentPanel.setLayout(new BorderLayout(5, 5));

				// ======== logoPanel ========
				{
					logoPanel.setLayout(new GridBagLayout());
					((GridBagLayout) logoPanel.getLayout()).columnWidths = new int[] {
							0, 0, 0, 0, 0 };
					((GridBagLayout) logoPanel.getLayout()).rowHeights = new int[] {
							0, 0 };
					((GridBagLayout) logoPanel.getLayout()).columnWeights = new double[] {
							0.0, 0.0, 0.0, 0.0, 1.0E-4 };
					((GridBagLayout) logoPanel.getLayout()).rowWeights = new double[] {
							0.0, 1.0E-4 };

					// ---- logoLabel ----
					DrawLogo northLogoPanel = new DrawLogo();
					logoPanel.add(northLogoPanel, new GridBagConstraints(0, 0,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(10, 10, 25, 5),
							300, 100));
				}
				contentPanel.add(logoPanel, BorderLayout.NORTH);

				// ======== loginPanel ========
				{
					loginPanel.setLayout(new GridBagLayout());
					((GridBagLayout) loginPanel.getLayout()).columnWidths = new int[] {
							53, 0, 184, 15, 0 };
					((GridBagLayout) loginPanel.getLayout()).rowHeights = new int[] {
							0, 0, 0, 0, 0, 48, 0 };
					((GridBagLayout) loginPanel.getLayout()).columnWeights = new double[] {
							1.0, 0.0, 1.0, 1.0, 1.0E-4 };
					((GridBagLayout) loginPanel.getLayout()).rowWeights = new double[] {
							0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0E-4 };

					// ---- loginLabel ----
					loginLabel.setText("Log-in Name:");
					loginPanel.add(loginLabel, new GridBagConstraints(1, 0, 1,
							1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 5, 5), 0,
							0));

					// ======== logPanel ========
					{
						logPanel.setLayout(new FlowLayout(FlowLayout.LEFT));

						// ---- loginField ----
						loginField.setColumns(20);
						logPanel.add(loginField);
					}
					loginPanel.add(logPanel, new GridBagConstraints(2, 0, 1, 1,
							0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 5, 5), 0,
							0));

					// ---- passwordLabel ----
					passwordLabel.setText("Password:");
					loginPanel.add(passwordLabel, new GridBagConstraints(1, 1,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 5, 5), 0,
							0));

					// ======== passPanel ========
					{
						passPanel.setLayout(new FlowLayout(FlowLayout.LEFT));

						// ---- passField ----
						passField.setColumns(20);
						passPanel.add(passField);
					}
					loginPanel.add(passPanel, new GridBagConstraints(2, 1, 1,
							1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 5, 5), 0,
							0));

					// ======== buttonPanel ========
					{
						buttonPanel.setLayout(new FlowLayout(FlowLayout.LEFT));

						// ---- loginButton ----
						loginButton.setText("Log-in");
						root.setDefaultButton(loginButton);
						loginButton.setToolTipText("Login");
						loginButton.addActionListener(new loginVerify());
						buttonPanel.add(loginButton);

						// ---- cancelButton ----
						cancelButton.setText("Cancel");
						cancelButton.setToolTipText("Cancel");
						cancelButton.addActionListener(new ClickCancel());
						buttonPanel.add(cancelButton);
					}
					loginPanel.add(buttonPanel, new GridBagConstraints(2, 2, 1,
							1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 5, 5), 0,
							0));

					// ---- forgotText ----

					try {
						forgotText
								.setText("<html><u>  Forgot your log-in or password?</u></html>");
						url = new URL("http://www.merklenet.com/");
						forgotText.setForeground(Color.blue);
						forgotText
								.setFont(new Font("SansSerif", Font.PLAIN, 11));
						forgotText.setToolTipText(url.toString());
						forgotText.addMouseListener(new MouseHandler());
					} catch (Exception e) {
						e.printStackTrace();
					}

					loginPanel.add(forgotText, new GridBagConstraints(2, 3, 1,
							1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 5, 5), 0,
							0));

					// ---- rememberBox ----
					rememberBox.setText("Remember");
					loginPanel.add(rememberBox, new GridBagConstraints(2, 4, 1,
							1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 5, 5), 0,
							0));

					// ---- remindText ----
					String text = "If you click this checkbox, your browswer will log you in\nautomatically everytime you"
							+ "visit this site provided you\ndon't click Log-out before leaving. This feature only \nworks if you have"
							+ "cookies enabled";
					remindText.append(text);
					remindText.setEditable(false);
					remindText.setOpaque(false);
					remindText.setFont(new Font("SansSerif", Font.PLAIN, 10));
					loginPanel.add(remindText, new GridBagConstraints(2, 5, 1,
							1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 0, 5), 0,
							0));
				}
				contentPanel.add(loginPanel, BorderLayout.CENTER);
			}
			dialogPane.add(contentPanel, BorderLayout.CENTER);
		}
		// ---- pack the window and display it ----
		mainWindow.pack();
		mainWindow.setVisible(true);
	}

	class ClickCancel implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			new SwitchBoard();
			mainWindow.dispose();
		}
	}

	class loginVerify implements ActionListener {
		public void actionPerformed(ActionEvent e) {

			username = ((JTextField) loginField).getText();
			password = ((JPasswordField) passField).getPassword();
			try {
				if (Employee.checkLogin(username, password)) {
					new guiVoteForWinner();
					mainWindow.dispose();
				} else {
					JOptionPane.showMessageDialog(null,
							"Incorrect username and password. Please try again!",
							"Error",
							JOptionPane.ERROR_MESSAGE);
					foo();
				}
			} catch (SQLException e1) {
				e1.printStackTrace();
			}
		}
	}

	class MouseHandler implements MouseListener {
		public void mousePressed(MouseEvent e) {

		}

		public void mouseReleased(MouseEvent e) {

		}

		public void mouseEntered(MouseEvent e) {
			forgotText.setCursor(new Cursor(Cursor.HAND_CURSOR));
		}

		public void mouseExited(MouseEvent e) {
			forgotText.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		}

		public void mouseClicked(MouseEvent e) {
			try {
				BrowserLauncher.openURL(url.toString());
			} catch (IOException e1) {
				e1.printStackTrace();
			}

		}

	}

	public void foo() {
		return;
	}

}
