/**@Author: 
 * Diana Mei Leng Wong
 * Michiko Chand
 * Nazih Ajami
 *@Date: November 8, 2006

 *Description: 
 *This class creates the GUI that a user encounters when he launches of the jar code. 
 *The main purpose of this class or GUI screen is to direct the user through the system. 
 *This class will currently initiate the LoginGUI.java and guiVoteForWinner.java classes 
 *depending on the user navigation choices.
 */

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.SQLException;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;

public class SwitchBoard {

	JFrame mainWindow;

	public static void main(String args[]) {
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				new SwitchBoard();
			}
		});
	}

	public SwitchBoard() {

		// ======== mainWindowFrame ========
		mainWindow = new JFrame();
		mainWindow.setTitle("Welcome");
		mainWindow.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		mainWindow.setLocation(300, 100);

		JPanel dialogPane = new JPanel();
		dialogPane.setLayout(new BorderLayout());
		dialogPane.setPreferredSize(new Dimension(500, 400));
		mainWindow.setContentPane(dialogPane);

		JPanel contentPanel = new JPanel();
		JPanel logoPanel = new JPanel();
		JPanel switchPanel = new JPanel();
		JButton nominateButton = new JButton();
		JButton voteButton = new JButton();
		JPanel icon1Panel = new JPanel();
		JPanel icon2Panel = new JPanel();

		// ======== dialogPane ========
		{
			dialogPane.setBorder(new EmptyBorder(12, 12, 12, 12));
			dialogPane
					.setBorder(new javax.swing.border.CompoundBorder(
							new javax.swing.border.TitledBorder(
									new javax.swing.border.EmptyBorder(0, 0, 0,
											0), "",
									javax.swing.border.TitledBorder.CENTER,
									javax.swing.border.TitledBorder.BOTTOM,
									new java.awt.Font("Dialog",
											java.awt.Font.BOLD, 12),
									java.awt.Color.red), dialogPane.getBorder()));
			dialogPane
					.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
						public void propertyChange(
								java.beans.PropertyChangeEvent e) {
							if ("border".equals(e.getPropertyName()))
								throw new RuntimeException();
						}
					});

			dialogPane.setLayout(new BorderLayout());

			// ======== contentPanel ========
			{
				contentPanel.setLayout(new GridBagLayout());
				((GridBagLayout) contentPanel.getLayout()).columnWidths = new int[] {
						0, 0 };
				((GridBagLayout) contentPanel.getLayout()).rowHeights = new int[] {
						0, 0, 0 };
				((GridBagLayout) contentPanel.getLayout()).columnWeights = new double[] {
						1.0, 1.0E-4 };
				((GridBagLayout) contentPanel.getLayout()).rowWeights = new double[] {
						0.0, 0.0, 1.0E-4 };

				// ======== logoPanel ========
				{
					logoPanel.setLayout(new GridBagLayout());
					((GridBagLayout) logoPanel.getLayout()).columnWidths = new int[] {
							0, 0, 0, 0 };
					((GridBagLayout) logoPanel.getLayout()).rowHeights = new int[] {
							0, 0 };
					((GridBagLayout) logoPanel.getLayout()).columnWeights = new double[] {
							0.0, 0.0, 0.0, 1.0E-4 };
					((GridBagLayout) logoPanel.getLayout()).rowWeights = new double[] {
							0.0, 1.0E-4 };

					// ---- logoLabel ----
					DrawLogo northLogoPanel = new DrawLogo();
					logoPanel.add(northLogoPanel, new GridBagConstraints(0, 0,
							1, 1, 0.0, 0.0, GridBagConstraints.CENTER,
							GridBagConstraints.BOTH, new Insets(0, 0, 0, 5),
							300, 100));
				}
				contentPanel.add(logoPanel,
						new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
								GridBagConstraints.CENTER,
								GridBagConstraints.BOTH, new Insets(0, 0, 60,
										0), 0, 0));

				//======== switchPanel ========
				{
					switchPanel.setLayout(new GridBagLayout());
					((GridBagLayout)switchPanel.getLayout()).columnWidths = new int[] {0, 17, 0, 0, 0, 0};
					((GridBagLayout)switchPanel.getLayout()).rowHeights = new int[] {0, 0, 0};
					((GridBagLayout)switchPanel.getLayout()).columnWeights = new double[] {1.0, 0.0, 0.0, 0.0, 1.0, 1.0E-4};
					((GridBagLayout)switchPanel.getLayout()).rowWeights = new double[] {0.0, 0.0, 1.0E-4};

					//======== icon1Panel ========
					{
						icon1Panel.setLayout(new GridBagLayout());
						((GridBagLayout)icon1Panel.getLayout()).columnWidths = new int[] {0, 0};
						((GridBagLayout)icon1Panel.getLayout()).rowHeights = new int[] {0, 0};
						((GridBagLayout)icon1Panel.getLayout()).columnWeights = new double[] {0.0, 1.0E-4};
						((GridBagLayout)icon1Panel.getLayout()).rowWeights = new double[] {0.0, 1.0E-4};

						//---- iconLabel1 ----
						DrawNominateIcon icon = new DrawNominateIcon();
						icon1Panel.add(icon, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
							GridBagConstraints.CENTER, GridBagConstraints.BOTH,
							new Insets(0, 0, 0, 0), 40, 30));
					}
					switchPanel.add(icon1Panel, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(0, 0, 20, 20), 0, 0));

					//---- nominateButton ----
					nominateButton.setText("Nominate Employees");
					nominateButton.setToolTipText("Nominate Employees");
					nominateButton.setBorderPainted(false);
					nominateButton.addActionListener(new NominateGUILaunch());
					switchPanel.add(nominateButton, new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(0, 0, 20, 20), 0, 0));

					//======== icon2Panel ========
					{
						icon2Panel.setLayout(new GridBagLayout());
						((GridBagLayout)icon2Panel.getLayout()).columnWidths = new int[] {0, 0};
						((GridBagLayout)icon2Panel.getLayout()).rowHeights = new int[] {0, 0};
						((GridBagLayout)icon2Panel.getLayout()).columnWeights = new double[] {0.0, 1.0E-4};
						((GridBagLayout)icon2Panel.getLayout()).rowWeights = new double[] {0.0, 1.0E-4};

						//---- iconLabel2 ----
						DrawFave star = new DrawFave();
						icon2Panel.add(star, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0,
							GridBagConstraints.CENTER, GridBagConstraints.BOTH,
							new Insets(0, 0, 0, 0), 40, 30));
					}
					switchPanel.add(icon2Panel, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(0, 0, 0, 20), 0, 0));

					//---- voteButton ----
					voteButton.setText("Vote for Winners");
					voteButton.setToolTipText("Vote for Winners");
					voteButton.setBorderPainted(false);
					voteButton.addActionListener(new VoteGUILaunch());
					switchPanel.add(voteButton, new GridBagConstraints(3, 1, 1, 1, 0.0, 0.0,
						GridBagConstraints.CENTER, GridBagConstraints.BOTH,
						new Insets(0, 0, 0, 20), 0, 0));
				}
				contentPanel.add(switchPanel, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0,
					GridBagConstraints.CENTER, GridBagConstraints.BOTH,
					new Insets(10, 0, 0, 0), 0, 0));
			}
			dialogPane.add(contentPanel, BorderLayout.CENTER);
		}
		
		// ---- pack the window and display it ----
		mainWindow.pack();
		mainWindow.setVisible(true);
	}

	class NominateGUILaunch implements ActionListener {
		public void actionPerformed(ActionEvent arg0) {
			try {
				new NominateGUI();
			} catch (SQLException e) {
				e.printStackTrace();
			}
			mainWindow.dispose();
		}
	}

	class VoteGUILaunch implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			new LoginGUI();
			mainWindow.dispose();
		}
	}

}
